#ifndef ACLFS_H
#define ACLFS_H

#include <sys/stat.h>
#include <limits.h>

enum ACL_CMD{
	ACL_OPEN,
	ACL_STAT,
	ACL_LSTAT,
	ACL_OPENDIR,
	ACL_UNLINK,
	ACL_RENAME,
	ACL_MKDIR,
	ACL_RMDIR,
	ACL_MKNOD,
	ACL_LINK,
	ACL_SYMLINK,
	ACL_CHMOD,
	ACL_CHOWN,
	ACL_LCHOWN,
	ACL_CHDIR,
	ACL_UTIMES,
	ACL_ACCESS,
};

struct ACL_REQUEST {
	ACL_CMD cmd;
	int mode;
	int perm;
	char paths[2*PATH_MAX];
};

enum ACL_STATUS {
	ACL_STATUS_FAIL,		// The request failed
	ACL_STATUS_OK,			// The request succeed, no special value
							// returned
	ACL_STATUS_HANDLE,		// A file handle was transmited
	ACL_STATUS_STAT,		// struc stat was sent
};

struct ACL_REPLY {
	ACL_STATUS status;
	int errcode;
};

#define ACLFS_SOCKET "/var/run/aclfs.s"

#endif

